<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/Settings/include/Settings/SettingInterface.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_8ae0dd75af039a94f4269584fb8eef13.html">Settings</a></li><li class="navelem"><a class="el" href="dir_432cbbb5245314b613ff1e5a0d6316fd.html">include</a></li><li class="navelem"><a class="el" href="dir_5ad71ff850730ae2a3f8f6d36f5ecd38.html">Settings</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">SettingInterface.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_setting_interface_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright 2018-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;).</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * You may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * A copy of the License is located at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     http://aws.amazon.com/apache2.0/</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * or in the &quot;license&quot; file accompanying this file. This file is distributed</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * express or implied. See the License for the specific language governing</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * permissions and limitations under the License.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#ifndef ALEXA_CLIENT_SDK_SETTINGS_INCLUDE_SETTINGS_SETTINGINTERFACE_H_</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#define ALEXA_CLIENT_SDK_SETTINGS_INCLUDE_SETTINGS_SETTINGINTERFACE_H_</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &lt;atomic&gt;</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;mutex&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;type_traits&gt;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;unordered_set&gt;</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_guarded_value_8h.html">AVSCommon/Utils/GuardedValue.h</a>&gt;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_set_setting_result_8h.html">Settings/SetSettingResult.h</a>&quot;</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_setting_observer_interface_8h.html">Settings/SettingObserverInterface.h</a>&quot;</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a> {</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">namespace </span>settings {</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> ValueT&gt;</div><div class="line"><a name="l00043"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html">   43</a></span>&#160;<span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html">SettingInterface</a> {</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00046"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#ad7cd5426acdf5103db1e03dfd4a51ab3">   46</a></span>&#160;    <span class="keyword">using</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#ad7cd5426acdf5103db1e03dfd4a51ab3">ValueType</a> = ValueT;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a3157e9ad281e270e4fafa721977645c5">   49</a></span>&#160;    <span class="keyword">using</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_setting_observer_interface.html">ObserverType</a> = <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_setting_observer_interface.html">SettingObserverInterface&lt;SettingInterface&lt;ValueType&gt;</a>&gt;;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="keyword">virtual</span> <a class="code" href="_set_setting_result_8h.html#a15f12c618d4b135e4f8eb35afe8a2ac5">SetSettingResult</a> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a71279bdc081594ac478f5680cbfbf83f">setLocalChange</a>(<span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#ad7cd5426acdf5103db1e03dfd4a51ab3">ValueType</a>&amp; value) = 0;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <span class="keyword">inline</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#ad7cd5426acdf5103db1e03dfd4a51ab3">ValueType</a> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a12421c86bb8fab5218c5d4dbdd4fdf20">get</a>() <span class="keyword">const</span>;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#aafcf4c4bdb2afe20a9b26648484b5f70">addObserver</a>(std::shared_ptr&lt;ObserverType&gt; observer);</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#aea3aa5f2529adbbd55bf6f578a5c6d25">removeObserver</a>(std::shared_ptr&lt;ObserverType&gt;&amp; observer);</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    <span class="keyword">virtual</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a1a7f6cdc887544b8a1e0e32e209d73cd">~SettingInterface</a>() = <span class="keywordflow">default</span>;</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;<span class="keyword">protected</span>:</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a98a48c39bc508f7a405283273acd84a8">SettingInterface</a>(<span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#ad7cd5426acdf5103db1e03dfd4a51ab3">ValueType</a>&amp; value);</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a1b7a51d0c65e32725b45e959086ad73a">notifyObservers</a>(<a class="code" href="namespacealexa_client_s_d_k_1_1settings.html#a65b348e86299aa3f3fcdf4a5f924e025">SettingNotifications</a> notification);</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;</div><div class="line"><a name="l00102"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a4e42d592da8a88af34fbd35902a5cb84">  102</a></span>&#160;    std::mutex <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a4e42d592da8a88af34fbd35902a5cb84">m_observerMutex</a>;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;</div><div class="line"><a name="l00105"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a5104c758d4c654e3940692035718b997">  105</a></span>&#160;    std::unordered_set&lt;std::shared_ptr&lt;ObserverType&gt;&gt; <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a5104c758d4c654e3940692035718b997">m_observers</a>;</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;</div><div class="line"><a name="l00108"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#ad2e51acb29ec4de6cfca094e5e871a1c">  108</a></span>&#160;    <span class="keyword">using</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_guarded_value.html">GuardedValue</a> = <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_guarded_value.html">avsCommon::utils::GuardedValue&lt;ValueType&gt;</a>;</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;</div><div class="line"><a name="l00111"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a0157ca24ccc6f088864ceedcd458bdb4">  111</a></span>&#160;    <span class="keyword">typename</span> std::conditional&lt;std::is_scalar&lt;ValueType&gt;::value, std::atomic&lt;ValueType&gt;, <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_guarded_value.html">GuardedValue</a>&gt;::type <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a0157ca24ccc6f088864ceedcd458bdb4">m_value</a>;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;};</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> ValueT&gt;</div><div class="line"><a name="l00115"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a12421c86bb8fab5218c5d4dbdd4fdf20">  115</a></span>&#160;ValueT <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a12421c86bb8fab5218c5d4dbdd4fdf20">SettingInterface&lt;ValueT&gt;::get</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    <span class="keywordflow">return</span> m_value;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;}</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> ValueT&gt;</div><div class="line"><a name="l00120"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#aafcf4c4bdb2afe20a9b26648484b5f70">  120</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#aafcf4c4bdb2afe20a9b26648484b5f70">SettingInterface&lt;ValueT&gt;::addObserver</a>(std::shared_ptr&lt;ObserverType&gt; observer) {</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    std::lock_guard&lt;std::mutex&gt;{m_observerMutex};</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    m_observers.insert(observer);</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;}</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> ValueT&gt;</div><div class="line"><a name="l00127"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a1b7a51d0c65e32725b45e959086ad73a">  127</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a1b7a51d0c65e32725b45e959086ad73a">SettingInterface&lt;ValueT&gt;::notifyObservers</a>(<a class="code" href="namespacealexa_client_s_d_k_1_1settings.html#a65b348e86299aa3f3fcdf4a5f924e025">SettingNotifications</a> notification) {</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    std::lock_guard&lt;std::mutex&gt;{m_observerMutex};</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    <span class="keywordflow">for</span> (<span class="keyword">auto</span>&amp; observer : m_observers) {</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;        ValueT value = m_value;</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        observer-&gt;onSettingNotification(value, notification);</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    }</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;}</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> ValueT&gt;</div><div class="line"><a name="l00136"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#aea3aa5f2529adbbd55bf6f578a5c6d25">  136</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#aea3aa5f2529adbbd55bf6f578a5c6d25">SettingInterface&lt;ValueT&gt;::removeObserver</a>(std::shared_ptr&lt;ObserverType&gt;&amp; observer) {</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    std::lock_guard&lt;std::mutex&gt;{m_observerMutex};</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;    m_observers.erase(observer);</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;}</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> ValueT&gt;</div><div class="line"><a name="l00142"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a98a48c39bc508f7a405283273acd84a8">  142</a></span>&#160;<a class="code" href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a98a48c39bc508f7a405283273acd84a8">SettingInterface&lt;ValueT&gt;::SettingInterface</a>(<span class="keyword">const</span> ValueT&amp; value) : m_value(value) {</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;}</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;}  <span class="comment">// namespace settings</span></div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;}  <span class="comment">// namespace alexaClientSDK</span></div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;<span class="preprocessor">#endif  // ALEXA_CLIENT_SDK_SETTINGS_INCLUDE_SETTINGS_SETTINGINTERFACE_H_</span></div><div class="ttc" id="classalexa_client_s_d_k_1_1settings_1_1_setting_interface_html_a4e42d592da8a88af34fbd35902a5cb84"><div class="ttname"><a href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a4e42d592da8a88af34fbd35902a5cb84">alexaClientSDK::settings::SettingInterface::m_observerMutex</a></div><div class="ttdeci">std::mutex m_observerMutex</div><div class="ttdoc">Mutex used to guard observers. </div><div class="ttdef"><b>Definition:</b> SettingInterface.h:102</div></div>
<div class="ttc" id="_setting_observer_interface_8h_html"><div class="ttname"><a href="_setting_observer_interface_8h.html">SettingObserverInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1settings_1_1_setting_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html">alexaClientSDK::settings::SettingInterface</a></div><div class="ttdef"><b>Definition:</b> SettingInterface.h:43</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1settings_1_1_setting_interface_html_a98a48c39bc508f7a405283273acd84a8"><div class="ttname"><a href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a98a48c39bc508f7a405283273acd84a8">alexaClientSDK::settings::SettingInterface::SettingInterface</a></div><div class="ttdeci">SettingInterface(const ValueType &amp;value)</div><div class="ttdef"><b>Definition:</b> SettingInterface.h:142</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1settings_1_1_setting_interface_html_aea3aa5f2529adbbd55bf6f578a5c6d25"><div class="ttname"><a href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#aea3aa5f2529adbbd55bf6f578a5c6d25">alexaClientSDK::settings::SettingInterface::removeObserver</a></div><div class="ttdeci">void removeObserver(std::shared_ptr&lt; ObserverType &gt; &amp;observer)</div><div class="ttdef"><b>Definition:</b> SettingInterface.h:136</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_guarded_value_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_guarded_value.html">alexaClientSDK::avsCommon::utils::GuardedValue</a></div><div class="ttdef"><b>Definition:</b> GuardedValue.h:28</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1settings_1_1_setting_interface_html_a0157ca24ccc6f088864ceedcd458bdb4"><div class="ttname"><a href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a0157ca24ccc6f088864ceedcd458bdb4">alexaClientSDK::settings::SettingInterface::m_value</a></div><div class="ttdeci">std::conditional&lt; std::is_scalar&lt; ValueType &gt;::value, std::atomic&lt; ValueType &gt;, GuardedValue &gt;::type m_value</div><div class="ttdoc">The setting value. (is_trivially_copyble is not supported on gcc4.8) </div><div class="ttdef"><b>Definition:</b> SettingInterface.h:111</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1settings_1_1_setting_interface_html_a1a7f6cdc887544b8a1e0e32e209d73cd"><div class="ttname"><a href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a1a7f6cdc887544b8a1e0e32e209d73cd">alexaClientSDK::settings::SettingInterface::~SettingInterface</a></div><div class="ttdeci">virtual ~SettingInterface()=default</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1settings_1_1_setting_interface_html_aafcf4c4bdb2afe20a9b26648484b5f70"><div class="ttname"><a href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#aafcf4c4bdb2afe20a9b26648484b5f70">alexaClientSDK::settings::SettingInterface::addObserver</a></div><div class="ttdeci">bool addObserver(std::shared_ptr&lt; ObserverType &gt; observer)</div><div class="ttdef"><b>Definition:</b> SettingInterface.h:120</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1settings_1_1_setting_interface_html_ad7cd5426acdf5103db1e03dfd4a51ab3"><div class="ttname"><a href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#ad7cd5426acdf5103db1e03dfd4a51ab3">alexaClientSDK::settings::SettingInterface::ValueType</a></div><div class="ttdeci">ValueT ValueType</div><div class="ttdoc">Define the setting value type. </div><div class="ttdef"><b>Definition:</b> SettingInterface.h:46</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1settings_1_1_setting_interface_html_a1b7a51d0c65e32725b45e959086ad73a"><div class="ttname"><a href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a1b7a51d0c65e32725b45e959086ad73a">alexaClientSDK::settings::SettingInterface::notifyObservers</a></div><div class="ttdeci">void notifyObservers(SettingNotifications notification)</div><div class="ttdef"><b>Definition:</b> SettingInterface.h:127</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1settings_1_1_setting_interface_html_a12421c86bb8fab5218c5d4dbdd4fdf20"><div class="ttname"><a href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a12421c86bb8fab5218c5d4dbdd4fdf20">alexaClientSDK::settings::SettingInterface::get</a></div><div class="ttdeci">ValueType get() const</div><div class="ttdef"><b>Definition:</b> SettingInterface.h:115</div></div>
<div class="ttc" id="_set_setting_result_8h_html"><div class="ttname"><a href="_set_setting_result_8h.html">SetSettingResult.h</a></div></div>
<div class="ttc" id="_set_setting_result_8h_html_a15f12c618d4b135e4f8eb35afe8a2ac5"><div class="ttname"><a href="_set_setting_result_8h.html#a15f12c618d4b135e4f8eb35afe8a2ac5">SetSettingResult</a></div><div class="ttdeci">SetSettingResult</div><div class="ttdef"><b>Definition:</b> SetSettingResult.h:21</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1settings_1_1_setting_interface_html_a71279bdc081594ac478f5680cbfbf83f"><div class="ttname"><a href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a71279bdc081594ac478f5680cbfbf83f">alexaClientSDK::settings::SettingInterface::setLocalChange</a></div><div class="ttdeci">virtual SetSettingResult setLocalChange(const ValueType &amp;value)=0</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_html"><div class="ttname"><a href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></div><div class="ttdoc">Whether or not curl logs should be emitted. </div><div class="ttdef"><b>Definition:</b> AVSConnectionManager.h:37</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1settings_html_a65b348e86299aa3f3fcdf4a5f924e025"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1settings.html#a65b348e86299aa3f3fcdf4a5f924e025">alexaClientSDK::settings::SettingNotifications</a></div><div class="ttdeci">SettingNotifications</div><div class="ttdef"><b>Definition:</b> SettingObserverInterface.h:27</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1settings_1_1_setting_observer_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1settings_1_1_setting_observer_interface.html">alexaClientSDK::settings::SettingObserverInterface</a></div><div class="ttdef"><b>Definition:</b> SettingObserverInterface.h:44</div></div>
<div class="ttc" id="_guarded_value_8h_html"><div class="ttname"><a href="_guarded_value_8h.html">GuardedValue.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1settings_1_1_setting_interface_html_a5104c758d4c654e3940692035718b997"><div class="ttname"><a href="classalexa_client_s_d_k_1_1settings_1_1_setting_interface.html#a5104c758d4c654e3940692035718b997">alexaClientSDK::settings::SettingInterface::m_observers</a></div><div class="ttdeci">std::unordered_set&lt; std::shared_ptr&lt; ObserverType &gt; &gt; m_observers</div><div class="ttdoc">Set of all observers of this setting. </div><div class="ttdef"><b>Definition:</b> SettingInterface.h:105</div></div>
</div><!-- fragment --></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
